
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>oracle查询转换_inlist转换 / 憋错料</title>

    <meta name="description" content="oracle查询转换_inlist转换 oracle的optimizer会对一些sql语句进行查询转换,比如: 合并视图 子查询非嵌套化 inlist转换 下面讲讲遇到的in list转化优化的案例: create table test( col1 varchar2(12) col2 number ext varchar2(4000) ); create index test_ind on test(user_id, col2); create sequence seq_test cache 200; 第一步:准备一些测试数据(10个">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">oracle查询转换_inlist转换</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P>oracle的optimizer会对一些sql语句进行查询转换，比如：</p>
<p><OL><LI>合并视图</LI><br />
  <LI>子查询非嵌套化</LI><br />
  <LI>inlist转换</LI></OL></p>
<p>下面讲讲遇到的in list转化优化的案例:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE>create table test(<br />
col1 varchar2(12)<br />
col2 number<br />
ext    varchar2(4000)<br />
);</p>
<p>create index test_ind on test(user_id, col2);<br />
create sequence seq_test cache 200;</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><P>第一步：准备一些测试数据（10个线程随机的插入数据）：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE>#!/bin/sh<br />
for((i=1;i&lt;=$1;i++))<br />
do<br />
        /home/oracle/insert.sh &amp;<br />
done<br />
#######################################################<br />
#!/bin/sh<br />
. /home/oracle/.bash_profile<br />
    sqlplus -S /nolog&lt;&lt;EOF<br />
        conn test/ali88<br />
        declare<br />
                type arraylist is table of varchar2(20 byte);<br />
                arr_user arraylist;<br />
                ran number;<br />
        begin<br />
                arr_user := arraylist();arr_user.extend(3);arr_user(1):=‘xpchild001‘;<br />
        arr_user(2):=‘xpchild002‘;arr_user(3):=‘xpchild003‘;<br />
                ran :=dbms_random.value(1,3);<br />
                while(1&gt;0) loop<br />
                        insert into  test(col1,col2,ext)values(arr_user(ran),seq_test.nextval,dbms_random.string(‘|‘, 300));<br />
                        commit;<br />
                DBMS_LOCK.SLEEP(0.05);<br />
                end loop;<br />
        end;<br />
        /<br />
EOF</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>下面看这个语句的执行计划：</p>
<p>　　</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE>delete from test t where col1 =:1 and col2 in<br />
( :2 , :3 , :4 , :5 , :6 , :7 , :8 , :9 , :10 , :11 , :12 , :13 , :14 , :15 , :16 , :17 , :18 , :19 , :20 , :21);</p>
<p>--------------------------------------------------------------------------------------------------------------<br />
| Id  | Operation                   | Name                           | Rows  | Bytes | Cost (%CPU)| Time     |<br />
--------------------------------------------------------------------------------------------------------------<br />
|   0 | SELECT STATEMENT            |                          |     4 |   948 |     5   (0)| 00:00:01 |<br />
|   1 |  TABLE ACCESS BY INDEX ROWID| test                     |     4 |   948 |     5   (0)| 00:00:01 |<br />
|*  2 |   INDEX RANGE SCAN          | test_ind                 |     4 |       |     2   (0)| 00:00:01 |<br />
--------------------------------------------------------------------------------------------------------------<br />
Predicate Information (identified by operation id):<br />
---------------------------------------------------<br />
   2 - access("col1"=:1)<br />
       filter("col2"=TO_NUMBER(:2) OR "col2"=TO_NUMBER(:3) OR<br />
        .........<br />
    "col2"=TO_NUMBER(:21))</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><P>分析：对于test_ind(col1,col2)这样的组合索引，oracle的优化器使用了access+filter的扫描方式，而对于热点表，或者col1存在大量记录的时候，<BR>	这样的扫描会从col1找到最小的col2,顺着leaf节点的链表，找到col2的最大值的区间里，进行filter，看下autotrace后的结果：</p>
<p>　　</p>
<p><PRE>Statistics<br />
----------------------------------------------------------<br />
12389    consistent gets<br />
20    rows</PRE></p>
<p>这里扫描了col1=:1前导列的所有leaf块，所以尽管只有20条记录，却有12389的逻辑读。</p>
<p>下面对这个sql进行inlist的查询转换：</p>
<p>　　</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE>ops$admin@orcl&gt;alter session set optimizer_index_caching=100;</p>
<p>delete /*+ use_concat*/from test t where col1 =:1 and col2 in<br />
( :2 , :3 , :4 , :5 , :6 , :7 , :8 , :9 , :10 , :11 , :12 , :13 , :14 , :15 , :16 , :17 , :18 , :19 , :20 , :21);</p>
<p>---------------------------------------------------------------------------------------------------------------<br />
| Id  | Operation                    | Name                           | Rows  | Bytes | Cost (%CPU)| Time     |<br />
---------------------------------------------------------------------------------------------------------------<br />
|   0 | SELECT STATEMENT             |                                |     4 |   948 |     3   (0)| 00:00:01 |<br />
|   1 |  INLIST ITERATOR             |                                |       |       |            |          |<br />
|   2 |   TABLE ACCESS BY INDEX ROWID| test                      |     4 |   948 |     3   (0)| 00:00:01 |<br />
|*  3 |    INDEX RANGE SCAN          | test_ind                  |     4 |       |     0   (0)| 00:00:01 |<br />
---------------------------------------------------------------------------------------------------------------<br />
Predicate Information (identified by operation id):<br />
---------------------------------------------------<br />
   3 - access("col1"=:1 AND ("col2"=TO_NUMBER(:2) OR "col2"=TO_NUMBER(:3) OR<br />
              "col2"=TO_NUMBER(:4) OR "col2"=TO_NUMBER(:5) OR "col2"=TO_NUMBER(:6) OR<br />
          ......<br />
  /*+<br />
      BEGIN_OUTLINE_DATA<br />
      NUM_INDEX_KEYS(@"DEL$1" "T"@"DEL$1" "test_ind" 2)<br />
      INDEX(@"DEL$1" "T"@"DEL$1" ("test"."col1"<br />
              "test"."col2"))<br />
      OUTLINE_LEAF(@"DEL$1")<br />
      ALL_ROWS<br />
      OPT_PARAM(‘optimizer_index_caching‘ 100)<br />
      OPT_PARAM(‘_gby_hash_aggregation_enabled‘ ‘false‘)<br />
      OPT_PARAM(‘_optim_peek_user_binds‘ ‘false‘)<br />
      OPT_PARAM(‘_index_join_enabled‘ ‘false‘)<br />
      OPT_PARAM(‘query_rewrite_enabled‘ ‘false‘)<br />
      OPTIMIZER_FEATURES_ENABLE(‘10.2.0.4‘)<br />
      IGNORE_OPTIM_EMBEDDED_HINTS<br />
      END_OUTLINE_DATA<br />
  */</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><P>注意：oracle的优化器会对in<br />
列表的查询转换为or的查询，使用use_concat的hint提示，使oracle可以把or的操作转化为concatenate的union<br />
all操作。<BR>但是这里如果想要转化为inlist的eterator操作，必须还要调整optimizer_index_caching，可以在system或者session级别，optimizer_index_caching的值的范围<BR>是0到100，表示的是百分比，这个参数影响oracle优化器在选择index时的cost计算，这里设置成100，表示扫描过的root，branch节点块都cache在buffer里，所以每次<BR>iterate从root到branch再到leaf节点时，oracle优化器认为cost会比较小，倾向于使用inlist<br />
iterator。</p>
<p>看一下autotrace后的结果：</p>
<p><PRE>Statistics<br />
----------------------------------------------------------<br />
81    consistent gets<br />
20    rows</PRE></p>
<p>即每条记录平均三个逻辑读，从root-&gt;branch-&gt;leaf-&gt;table block。</p>
<p>　　如果在生产环境中可以使用profile来固定上面的执行计划，这样不用更改任何的代码逻辑:</p>
<p>　　</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"><br /><PRE>declare<br />
  v_hints      sys.sqlprof_attr;<br />
  sql_fulltext clob;<br />
begin<br />
  select SQL_FULLTEXT<br />
    into sql_fulltext<br />
    from v$sqlarea<br />
   where sql_id = ‘xxxxxx‘;<br />
  v_hints := sys.sqlprof_attr(‘NUM_INDEX_KEYS(@"DEL$1" "T"@"DEL$1" "test_ind" 2)‘,<br />
                              ‘INDEX(@"DEL$1" "T"@"DEL$1" ("test"."col1"‘,<br />
                  ‘"test"."col2"))‘,<br />
                  ‘OUTLINE_LEAF(@"DEL$1")‘,<br />
                  ‘ALL_ROWS‘,<br />
                  ‘OPT_PARAM(‘‘optimizer_index_caching‘‘ 100)‘);<br />
  dbms_sqltune.import_sql_profile(sql_fulltext,<br />
                                  v_hints,<br />
                                  ‘test‘,<br />
                                  force_match =&gt; true);<br />
end;<br />
/</PRE></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><P>　　</p>
<p><A href="http://www.bubuko.com/infodetail-153968.html" rel="external nofollow noreferrer">oracle查询转换_inlist转换,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 22:27:42 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/string/" title="string">string</a>, <a href="https://www.biecuoliao.com/tag/com/" title="&period;com">&period;com</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/img/" title="img">img</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/javascript/" title="javascript">javascript</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>oracle查询转换_inlist转换的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/x0d7WZM.html" rel="bookmark">oracle查询转换&lowbar;view merge</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				oracle对于子查询的支持做的很好,oracle optimizer会对inline view进行query transfomation,即视图合并,不过也经常带来意想不到的问题.下面是一个inline view的merge的例子: 1, 创建临时表 1 create table test1 as select * from dba_objects; 2 create table test2 as select * from dba_objects; 2, 以下查询语句 select * fr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xDPb70.html" rel="bookmark">Oracle中使用游标转换数据表中指定字段内容格式&lpar;拼音转数字&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				应用场景:将数据表TB_USER中字段NNDP的内容中为[sannanyinv]转换为[3男1女] 主要脚本:一个游标脚本+分割字符串函数+拼音转数字脚本 操作步骤如下: 1.创建类型 create or replace type splitTable is table of varchar2(100); 2.创建函数fn_splitString(功能是将字符串分割成多条记录)--测试语句select * from table(fn_splitString('ernanyinv','nan'))			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q2562M.html" rel="bookmark">SQL语句优化系列四（Oracle数据库日期格式转换）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle数据库日期格式转换 select sysdate from dual select to_char(sysdate,'yyyy/mm/dd hh24:mi:ss') as mydate from dual select to_char(sysdate,'yyyy-mm-dd hh24:mi:ss') as mydate from dual select to_number(to_char(sysdate,'yyyymmddhh24miss')) as mydate from dual			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p5AAoM.html" rel="bookmark">sql server 导出的datetime结果 CAST&lpar;0x00009E0E0095524F AS DateTime&rpar; 如何向mysql&comma;oracle等数据库进行转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在进行sql server向mysql等其他数据进行迁移数据时,会发现使用sql server导出的datetime类型的结果是16进制表示的二进制的结果,类似于:CAST(0x00009E0E0095524F AS DateTime),这样形式的datetime是无法向其他数据库插入的,所以需要将这种表现形式进行转换.搜索了很久,才在在stackoverflow上找到正确的转换方法.在网上看到很多人都这个问题都不知道解决办法,本文采用Java语言根据stackoverflow介绍的原理,进行编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kZn8EM.html" rel="bookmark">关于EXP-00056&colon; 遇到 ORACLE 错误 1455  ORA-01455&colon; 转换列溢出整数数据类型  EXP-00000&colon; 导出终止失败  的问题解决方法整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在客户端用exp导出数据库的时候,遇到如下情况 ... .... ...... .. 正在导出同义词 . 正在导出视图 EXP-00056: 遇到 ORACLE 错误 1455 ORA-01455: 转换列溢出整数数据类型 EXP-00000: 导出终止失败 在导完表.同义词.视图后出现EXP-00056: 遇到 ORACLE 错误 1455 这样的问题我连续遇到两次. 我查过网上许多帖子,解决方法都不一样: 第一种: SQL&gt; connect / as sysdba SQL&gt; @catmet			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NqEA63.html" rel="bookmark">oracle 字符串与日期转换sql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				常用sql语句: select to_char(sysdate,'yy-mm-dd hh24:mi:ss') from dual;   //显示:08-11-07 13:22:42 select to_date('2005-12-25,13:25:59','yyyy-mm-dd,hh24:mi:ss') from dual; //显示:2005-12-25 13:25:59 获取系统时间: select sysdate from dual; 转换的格式: 表示year的:y  表示年的最后一位			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qG2k7M.html" rel="bookmark">hibernate查询部分字段转换成实体bean</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//hibernate查询部分字段转换成实体bean /** * 查询线路信息 */ @Override public List&lt;Line&gt; getSimpleLineListByTj(Map&lt;String,Object&gt; paramMap){ Criteria cr=this.getSession().createCriteria(Line.class,&quot;Line&quot;); // cr.setFetchMode(&quot;chuTuanInfo&quot;, F			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPBGjm3.html" rel="bookmark">ORACLE函数之单行转换函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				﻿﻿ 1           ASCIISTR 格式:ASCIISTR(C) 说明:将字符串C转换为ASCII字符串,即将C中的ASCII字符保留不变,但非ASCII字符则以ASCII表示返回 举例: SQL&gt;SELECT ASCIISTR('AB?CDE数据库') A FROM DUAL; A --------------------- AB?CDE\6570\636E\5E93 2           BIN_TO_NUM 格式:BIN_TO_NUM(n1,n2,n3...) 说明:每位由n			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35Ve5E4.html" rel="bookmark">45个非常有用的 Oracle 查询语句小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				﻿﻿ 这里我们介绍的是 40+ 个非常有用的 Oracle 查询语句,主要涵盖了日期操作,获取服务器信息,获取执行状态,计算数据库大小等等方面的查询.这些是所有 Oracle 开发者都必备的技能,所以快快收藏吧. 原文地址:http://www.jbxue.com/db/19890.html 日期/时间 相关查询 1.获取当前月份的第一天 运行这个命令能快速返回当前月份的第一天.你可以用任何的日期值替换 &quot;SYSDATE&quot;来指定查询的日期. 复制代码代码如下: SELECT TRUNC			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzJ7qM.html" rel="bookmark" class="title">学籍管理系统（Java初级版）</a>
					<div>
						import java.util.Scanner; /**  * 学籍管理系统  * @author Tanker  * @version 4.6.0  */  public class XueJiS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kalp4.html" rel="bookmark" class="title">【ESXI6&period;0】Vmware ESXI 6&period;0 【Customize System&sol;View Logs】简介</a>
					<div>
						Vmware ESXI 6.0 安装完毕后重启进入如下界面. 按F2进入系统设置与日志查询.会要求输入帐号密码.如下图 进入后界面如下图 Configure Password 修改密码简单不表.符合密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywlDY3.html" rel="bookmark" class="title">转：从《The C Programming Language》中学到的那些编程风格和设计思想</a>
					<div>
						这儿有一篇写的很好的读后感:http://www.cnblogs.com/xkfz007/articles/2566424.html 读书不是目的,关键在于思考. 很早就在水木上看到有人推荐&lt;T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412orOM.html" rel="bookmark" class="title">2015年有很多游戏公司倒闭，他们都长啥样？（转）</a>
					<div>
						Hello,大家好,国庆假期回来刚3天,本期佳伦说我们用文字的方式与大家聊天,游戏行业新手训练营的系列视频请看下期. 今天聊聊移动游戏行业的倒闭潮,从今年春节过后开始,碰到很多游戏行业的创业者,很多都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5arl0.html" rel="bookmark" class="title">JVM各种变量存储位置</a>
					<div>
						Java中变量分为静态变量,实例变量,临时变量.他们在JVM中存储的位置如下:静态变量    位于方法区实例变量    作为对象的一部分,保存在堆中.临时变量    保存于栈中,栈随线程的创建而被分配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ZqkyM.html" rel="bookmark" class="title">iOS笔记，开发经验总结【持续更新】</a>
					<div>
						1. 设置navigationBar 背景颜色有色差, 原因:如果单纯的设置背景颜色也是有高斯模糊处理的效果,对纯色高斯模糊处理过后相当于纯色的70%(猜测)透明化处理,但是反正就是有色差 解决方法一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlWqp4.html" rel="bookmark" class="title">iOS真机测试友盟碰到错误linker command failed with exit code 1 &lpar;use -v to see invocation&rpar;  百度地图的检索失败  sqlite 错误码</a>
					<div>
						因为友盟不支持bitcode 在模拟器上运行正常,但是在模拟器上就会报错,这是因为xocde7之后增加了一个bitcode,bitcode是被编译程序的一种中间形式的代 码.包含bitcode配置的程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jkr5VM.html" rel="bookmark" class="title">CAS代理配置</a>
					<div>
						CAS Server:www.sinosoft.com 代理服务:palace.sinosoft.com 被代理服务:gguser.sinosoft.com 1. 建立key,命令如下: keytoo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5bOZ3.html" rel="bookmark" class="title">ssh的认识</a>
					<div>
						其实这个ssh框架(struts+spring+hibernate),就是著名的三大框架,只能说是这个java的ejb是官方的框架,这个ssh是这个民间的山寨的框架,但是这个官方的ejb框架好看,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYVn5M.html" rel="bookmark" class="title">python中的拷贝</a>
					<div>
						再说拷贝之前先说一说 is 与 == is 的作用是 比较两个引用是否为一个地址 == 是比较两个值 对变量 a  变量 b  都赋值为 2 : a 与 b 的值相等我们都可以理解,但是a与b引用地址 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRw2y0.html" rel="bookmark" class="title">app&period;use 的作用   正则表达式中&sol;  表示什么   nodejs pm2 怎样安装    乱码怎么解决</a>
					<div>
						1.express 框架中的app.use是什么作用? 手册上写着是: app.use([path], function)Use the given middleware function, with ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXjbWM.html" rel="bookmark" class="title">Docker学习笔记（一）&colon;Docker的三个基本概念</a>
					<div>
						Docker 包括三个基本概念 镜像(Image) 容器(Container) 仓库(Repository) 理解了这三个概念,就理解了 Docker 的整个生命周期. 镜像Image Docker  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORP2X0.html" rel="bookmark" class="title">Java List排序</a>
					<div>
						List排序大体上分为如下两类: 1.List&lt;Integer&gt; 对Integer.String等类型的List排序 2.List&lt;Object&gt; 对自定义对象的排序 本文代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkVWV3.html" rel="bookmark" class="title">DiskFileItemFactory类的使用</a>
					<div>
						将请求消息实体中的每一个项目封装成单独的DiskFileItem (FileItem接口的实现) 对象的任务由 org.apache.commons.fileupload.FileItemFactor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAbld4.html" rel="bookmark" class="title">&lbrack;Android Studio&rsqb; Android Studio如何快速生成get，set，tostring，构造函数</a>
					<div>
						刚开始使用Android Studio时,在创建一个javabean时,很习惯的在JavaBean类中,右键去找生成get,set等选项.但是很遗憾,找不到. 那这边如何快速的set,get或者生成构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVz5QdM.html" rel="bookmark" class="title">九度OJ 1097 取中值</a>
					<div>
						题目1097:取中值 时间限制:1 秒 内存限制:32 兆 特殊判题:否 提交:4379 解决:1188 题目描述: 存在两组数组,和4个数字a,b,c,d,要求做如下操作,将第一个数组第a个数到第b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7lEj3.html" rel="bookmark" class="title">DNS服务之智能DNS</a>
					<div>
						前言和实验背景 智能DNS是一个很关键的应用,也是直观体现工资的一项技能.智能DNS现在的技术已经非常的成熟,而且可以进化成CDN(内容分发网络).基本掌握了智能DNS和CDN的技术,就代表已经成为一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nn1WV4.html" rel="bookmark" class="title">cocos2d-x之用户默认的首选项</a>
					<div>
						在bool HelloWorld::init()中 1 // //写入用户的首选项数据,会在本地生成一个文件,即使应用程序被关闭掉, 2 // //再下次重开的时候还可以访问到这个数据.存储一个字符串 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8yJY3.html" rel="bookmark" class="title">申请Bing Search API</a>
					<div>
						地址:https://datamarket.azure.com/home 没有帐号先注册一个,然后登录. 1:在数据中订阅Bing Search API,如果找不到就使用这个地址: https://d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Xe2z4.html" rel="bookmark" class="title">如何在virtualenv虚拟环境中安装mysql-python</a>
					<div>
						接触过virtualenv后,想在这个虚拟环境中安装独立的开发环境.在安装MySQLdb时遇到错误 pc 09:09:30 File &quot;/home/pc/work/VENV/py3/loca ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
